void msg(const char* messaggio)
{
  if (messaggio[0] != '\a') /* Con '\a' non mostra niente a schermo */
  {
    int lung = strlen(messaggio);
    int x = 320 - (lung * 8 / 2);
    boxColor(schermo, x - 10, 228, x + (8 * lung) + 10, 257, 0x006400FF);
    stringColor(schermo, x, 240, messaggio, 0xFFFFFFFF);
    rectangleColor(schermo, x - 8, 230, x + (8 * lung) + 8, 255, 0xAA0000FF);
    SDL_Flip(schermo);
  }
  SDL_PumpEvents();
  if (tasto[SDLK_SPACE]) while(tasto[SDLK_SPACE]) { SDL_PumpEvents(); SDL_Delay(20); }
  while (! tasto[SDLK_SPACE])
  { SDL_PumpEvents(); SDL_Delay(20); }
}

int cursorX = 20, cursorY = 20;

/* Scrive con effetto Commodore64 (a ritardo) */
static void scrivi(const char * stringa)
{
  for (short c = 0; c < strlen(stringa); c++)
  {
    switch (stringa[c])
    {
      case '\n': cursorY = cursorY + 10; cursorX = 20; break;
      case '\a': cursorX = 20; cursorY = 20; break;
      default: characterColor(schermo, cursorX, cursorY, stringa[c], 0x00EE00FF);
    }
    cursorX = cursorX + 8;
    if (cursorX > 620) { cursorX = 20; cursorY = cursorY + 10; }
    SDL_Delay(10);
    SDL_Flip(schermo);
  }
}

void info()
{
  boxColor(schermo, 0, 0, 639, 479, 0x000000FF);
  scrivi("\n");
  scrivi("\aP Pong\nby Giovan Battista Rolandi\n");
  scrivi("\n");
  scrivi("Istruzioni:\n");
  scrivi("Lo scopo del gioco consiste nel distruggere tutti i mattoni nell'area di\n");
  scrivi("gioco con una palla. La palla rimbalza automaticamente sui mattoni, sui\n");
  scrivi("bordi e sulla racchetta, che viene mossa dal giocatore.\n");
  scrivi("Se la palla non viene colpita dalla racchetta, il giocatore viene\n");
  scrivi("penalizzato. Se la palla viene persa piu' volte di seguito, il gioco\n");
  scrivi("termina.\n");
  scrivi("Ogni mattone, a seconda del colore con cui viene mostrato, da' al\n");
  scrivi("giocatore un diverso punteggio. Alcuni mattoni devono essere colpiti piu'\n");
  scrivi("volte, prima che vengano definitivamente distrutti.\n");
  scrivi("Inoltre vi sono alcuni mattoni speciali, che permettono di modificare la\n");
  scrivi("velocita' della palla, la dimensione della racchetta, ecc...\n");
  scrivi("Una volta colpiti e distrutti tutti i mattoni presenti sullo schermo,\n");
  scrivi("e' possibile passare al livello successivo; non e' necessario colpire i\n");
  scrivi("mattoni che danno diritto a dei bonus.\n");
  scrivi("\n");
  scrivi("Comandi:\n");
  scrivi("Frecce direzionali per muovere la racchetta a sinistra e destra\n");
  scrivi("P     Pausa\n");
  scrivi("A     Abbandona il livello\n");
  scrivi("ESC   Autodistruzione\n");
  scrivi("\n");
  scrivi("Licenza:\n");
  scrivi("Questo programma viene distribuito cosi' com'e' senza alcuna garanzia.\n");
  scrivi("L'autore non e' responsabile di nessun danno a cose o persone derivato\n");
  scrivi("dall'utilizzo di questo gioco, specialmente se improprio.\n");
  scrivi("I sorgenti di questo programma possono essere utilizzati a scopo ludico,\n");
  scrivi("didattico e informativo, a condizione che ne venga citata la fonte.\n");
  scrivi("E' assolutamente vietato utilizzare il programma a scopo di lucro, sia\n");
  scrivi("nella sua forma in codice che in quella compilata.\n");
  scrivi("\n");
  scrivi("Informazioni:\n");
  scrivi("Nome del gioco:   P Pong\n");
  scrivi("Versione:         "); scrivi(versione); scrivi("\n");
  scrivi("Programmatore:    Giovan Battista Rolandi http://gbr.altervista.org\n");
  scrivi("Linguaggio:       C++\n");
  scrivi("Piattaforma:      Linux - Mac OS X - Windows\n");
  scrivi("Data:             Luglio - Agosto 2012\n");
  scrivi("Ulteriori informazioni sono disponibili da riga di comando con opzione -h\n");
  scrivi("\n");
  scrivi("PS: Questo effetto Commodore64 e' molto accattivante :D");
  SDL_Delay(1000);
  msg("\a");
}

void infocmd()
{
  cout << endl;
  cout << "P Pong" << endl;
  cout << "Opzioni accettate da riga di comando:" << endl;
  cout << " -l #  Avvia il gioco dal livello # specificato" << endl;
  cout << " -f    Avvia il gioco a schermo intero (passare come ultimo parametro!)" << endl;
  cout << "         Nota: non funziona su tutti i tipi di monitor" << endl;
  cout << " -v    Visualizza il numero di versione del programma" << endl;
  cout << " -h    Mostra questo messaggio d'aiuto" << endl;
  cout << endl;
}

void infolog()
{
  cout << "P Pong version " << versione << endl;
  cout << "Here in command line you can read the program's log, so you can check" << endl;
  cout << "for errors and report them." << endl;
  cout << "[I] is a piece of information which program normally outputs" << endl;
  cout << "[W] indicates a Warning, so something went wrong but the program was able to fix" << endl;
  cout << "[E] indicates a Fatal Error, so the program may crash or be unstable." << endl;
  cout << "When an [E] error occurs, you may consider to restart the program." << endl;
  cout << endl;
}
