/* Legge livello da file, a partire dall'offset passato come parametro */
bool readlvl(unsigned long b)
{
  cout << "[I] Reading level from file... ";
  unsigned int nBlocks = width * height;
  char info[nBlocks];
  if (! filelvl) { cerr << "[E] Fatal error: unable to open file to readlvl()!\n"; return false; }
  filelvl.seekg(b, ios::beg);
  filelvl.read(info, nBlocks);
  if (! filelvl.failbit) { cerr << "[E] Fatal error: unable to parse file to readlvl()!\n"; return false; }
  if (info[0] == 'F') { cerr << "[W] Level file says it is finished\n"; return false; }
  /* Imposta il titolo come nome del livello */
  for (unsigned int c = 0; c < width; c++)
    { title[c] = info[c]; }
  cout << title << endl;
  SDL_WM_SetCaption(title, 0);
  for (unsigned int c = width; c < nBlocks; c++)
  {
    block[c % width][c / width] = info[c];
  }
  return true;
}

static bool livello()
{
  /* NB: La funzione deve ritornare true se il livello è stato caricato correttamente!!
   * EDIT: Non è indispensabile che il livello venga letto da file, lo si può generare
   * automaticamente [questa possibilità è stata ridotta]
   */
  for (short y = 0; y < height; y++) for (short x = 0; x < width; x++) block[x][y] = 0;
  lvl++;
  if (readlvl(384 * (lvl - 1) + 16)) { return true; }
    else
    {
      clog << "[W] Unable to load the level! Loading default level\n";
      msg("Impossibile leggere questo livello: caricamento del livello Automatico.");
      SDL_WM_SetCaption("P Pong - Livello automatico", 0);
      strcpy(title, "Automatico");
      for (short x = 1; x < width - 1; x++)
        block[x][2] = 10;
      return true;
    }
  return false;
}

